{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/css/select2.min.css" rel="stylesheet"/>
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">
    <link rel="stylesheet" type="text/css" href="{% static "courses/css/landing_page.css" %}">
    <style>
        .dataTables_filter {
            display: none;
        }
    </style>
{% endblock specific_css %}


{% block content %}
    <div class="container">
        <div class="row my-5 justify-content-center">
            <h3>Search Assignments</h3>
        </div>
        <div class="row my-5">
            <div class="col">
                <span>Title &nbsp;</span>
                <span>
            <select id="select-title" class="filter" autocomplete="off" multiple style="width: 400px;">
                {% for title in titles %}
                    <option value="{{ title }}">{{ title }}</option>
                {% endfor %}
            </select>
        </span>
            </div>
            <div class="col">
                <span>Tags &nbsp;</span>
                <span>
            <select id="select-tags" class="filter" autocomplete="off" multiple style="width: 400px;">
                {% for tag in tags %}
                    <option value="{{ tag }}">{{ tag }}</option>
                {% endfor %}
            </select>
        </span>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <table id="assignments_table" class="table table-hover">
                    <thead>
                    <tr>
                        <th>Title</th>
                        <th>Course</th>
                        <th>Tags</th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
{% endblock content %}


{% block specific_js %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/js/select2.min.js"></script>
    <script type="text/javascript" charset="utf8"
            src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>

    <!-- Javascript here because otherwise the Django tags will not work -->
    <script type="text/javascript">
        $(document).ready(function () {
            $(".filter").select2();

            let table = $('#assignments_table');

            // function to load the datatable
            const load = (params) => {
                // first we clone the params
                let clean_params = {"titles": [], "tags": []};
                clean_params.title = [... params.title];
                clean_params.tag = [... params.tag];

                // if params was empty we want to simply show everything
                if (params.title.length === 0 && params.tag.length === 0) {
                    {% for title in titles %}
                        clean_params.title.push('{{ title }}');
                    {% endfor %}
                    {% for tag in tags %}
                        clean_params.tag.push('{{ tag }}');
                    {% endfor %}
                }

                // if the datatable was created before we destroy it
                table.DataTable().destroy();

                // generate datatable
                table.DataTable({
                    "processing": true,
                    "ajax": {
                        "processing": true,
                        "url": "{% url 'assignments_as_json' %}",
                        "method": 'GET',
                        "data": clean_params,
                        "dataSrc": ""
                    },
                    "columns": [
                        {"data": null, render: function (data, type, full, meta) {
                                return '<a href="/assignments/' + full["pk"] + '">' + full["fields"]["title"] + '</a>';
                            }
                        },
                        {"data": null, render: function (data, type, full, meta) {
                                return '<a href="/assignments/' + full["pk"] + '">' + full["fields"]["course"] + '</a>';
                            }
                        },
                        {"data": null, render: function (data, type, full, meta) {
                                let val = '<a href="/assignments/' + full["pk"] + '">';

                                if (full["fields"]["tags"].length == 0) {
                                    val += "There are no tags to show."
                                } else {
                                    for (k = 0; k < full["fields"]["tags"].length; k++) {
                                        val += "#" + full["fields"]["tags"][k] + " ";
                                    }
                                }
                                val += '</a>';
                                return val;
                            }
                        }
                    ]
                });
            };

            // initially the search terms are empty
            let searchTerms = {"title": [], "tag": []};

            // load datatable
            load(searchTerms);

            let select_title = $('#select-title');

            // add to search terms
            select_title.on('select2:select', function (e) {
                let data = e.params.data;
                searchTerms.title.push(data['text']);
                load(searchTerms);
            });

            // remove from search terms
            select_title.on('select2:unselect', function (e) {
                let data = e.params.data;
                for (let i = 0; i < searchTerms.title.length; i++) {
                    if (searchTerms.title[i] === data['text']) {
                        searchTerms.title.splice(i, 1);
                        i--;
                    }
                }
                load(searchTerms);
            });

            let select_tag = $('#select-tags');

            // add to search terms
            select_tag.on('select2:select', function (e) {
                let data = e.params.data;
                searchTerms.tag.push(data['text']);
                load(searchTerms);
            });

            // remove from search terms
            select_tag.on('select2:unselect', function (e) {
                let data = e.params.data;
                for (let i = 0; i < searchTerms.tag.length; i++) {
                    if (searchTerms.tag[i] === data['text']) {
                        searchTerms.tag.splice(i, 1);
                        i--;
                    }
                }
                load(searchTerms);
            });
        });
    </script>

    <script>
    $("#search_assignments_light").css("font-weight", "Bold");
    </script>

{% endblock specific_js %}